03-04 创建和编辑AutoCAD实体(四) 编辑二维命名对象 (7)

 

9、Edit Polylines编辑多段线

2D and 3D polylines, rectangles, polygons, donuts, and 3D polygon meshes are all polyline variants and are edited in the same way.

二维多段线和三维多段线、矩形、多边形、圆环以及三维多边形网格都是多段线的变体,可以使用相同的方法对其进行编辑。

AutoCAD recognizes both fit polylines and spline-fit polylines. A spline-fit polyline uses a curve fit, similar to a B-spline. There are two kinds of spline-fit polylines: quadratic and cubic. Both polylines are controlled by the SPLINETYPE system variable. A fit polyline uses standard curves for curve fit and utilizes any tangent directions set on any given vertex.

AutoCAD能够识别拟合多段线和样条曲线拟合多段线。样条曲线拟合多段线使用曲线拟合而成,类似于B样条曲线。有两种样条曲线拟合多段线:二次的和三次的,两种多段线均由系统变量SPLINETYPE控制。拟合多段线使用标准曲线利用在给定顶点设置切线方向拟合而成。

To edit a polyline, use the properties and methods of the Polyline, Polyline2d, or Polyline3d object. Use the following properties and methods to open or close a polyline, change the coordinates of a polyline vertex, or add a vertex:

使用Polyline对象、 Polyline2d对象或Polyline3d对象的属性和方法来编辑多段线。下列属性和方法用于开放或闭合多段线、改变多段线顶点坐标、增加顶点等:

Closed 属性

Opens or closes the polyline. 开放或闭合多段线;

ConstantWidth 属性

Sets the constant width for a lightweight and 2D polyline. 设置轻量级和2D多段线宽度常量;

AppendVertex 方法

Adds a vertex to a 2D or 3D polyline. 给2D或3D多段线增加顶点;

AddVertexAt 方法

Adds a vertex to a lightweight polyline. 给轻量级多段线增加顶点;

ReverseCurve 方法

Reverses the direction of the polyline. 掉换多段线方向;

 

Use the following methods to update the bulge or width of a polyline:

下列方法用于修改多段线的凸度或宽度:

SetBulgeAt 方法

Sets the bulge of a light polyline, given the segment index. 给定线段索引,设置多段线的凸度;

SetStartWidthAt 方法

Sets the start width of a lightweight polyline, given the segment index. 给定线段索引,设置轻量级多段线的起始宽度;

Straighten方法

Straightens a 2D or 3D polyline. 拉直2D或3D多段线

For more information about editing polylines, see “Modify or Join Polyline” in theUser's Guide.

关于编辑多段线的更多内容,见AutoCAD用户指南中的“修改或连结多段线”。

Edit a polyline 编辑多段线

This example creates a lightweight polyline. It then adds a bulge to the third segment of the polyline, appends a vertex to the polyline, changes the width of the last segment, and finally closes the polyline.

本例创建一条轻量级多段线,然后将第三条线段变成曲线(添加凸度)、追加一个顶点、修改最后那条线段的宽度,最后闭合该多段线。

VB.NET

Imports Autodesk.AutoCAD.Runtime

Imports Autodesk.AutoCAD.ApplicationServices

Imports Autodesk.AutoCAD.DatabaseServices

Imports Autodesk.AutoCAD.Geometry

 

<CommandMethod("EditPolyline")> _

Public Sub EditPolyline()

  '' Get the current document and database

  Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument

  Dim acCurDb As Database = acDoc.Database

 

  '' Start a transaction

  Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()

 

      '' Open the Block table for read

      Dim acBlkTbl As BlockTable

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, _

                                   OpenMode.ForRead)

 

      '' Open the Block table record Model space for write

      Dim acBlkTblRec As BlockTableRecord

      acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), _

                                      OpenMode.ForWrite)

 

      '' Create a lightweight polyline

      Dim acPoly As Polyline = New Polyline()

      acPoly.AddVertexAt(0, New Point2d(1, 1), 0, 0, 0)

      acPoly.AddVertexAt(1, New Point2d(1, 2), 0, 0, 0)

      acPoly.AddVertexAt(2, New Point2d(2, 2), 0, 0, 0)

      acPoly.AddVertexAt(3, New Point2d(3, 2), 0, 0, 0)

      acPoly.AddVertexAt(4, New Point2d(4, 4), 0, 0, 0)

 

      '' Add the new object to the block table record and the transaction

      acBlkTblRec.AppendEntity(acPoly)

      acTrans.AddNewlyCreatedDBObject(acPoly, True)

 

      '' Sets the bulge at index 3

      acPoly.SetBulgeAt(3, -0.5)

 

      '' Add a new vertex

      acPoly.AddVertexAt(5, New Point2d(4, 1), 0, 0, 0)

 

      '' Sets the start and end width at index 4

      acPoly.SetStartWidthAt(4, 0.1)

      acPoly.SetEndWidthAt(4, 0.5)

 

      '' Close the polyline

      acPoly.Closed = True

 

      '' Save the new objects to the database

      acTrans.Commit()

  End Using

End Sub

C#

using Autodesk.AutoCAD.Runtime;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

using Autodesk.AutoCAD.Geometry;

 

[CommandMethod("EditPolyline")]

public static void EditPolyline()

{

  // Get the current document and database获取当前文档和数据库

  Document acDoc = Application.DocumentManager.MdiActiveDocument;

  Database acCurDb = acDoc.Database;

 

  // Start a transaction启动事务

  using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())

  {

      // Open the Block table for read以读打开块表

      BlockTable acBlkTbl;

      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,

                                   OpenMode.ForRead) as BlockTable;

 

      // Open the Block table record Model space for write

      // 以写打开块表记录模型空间

      BlockTableRecord acBlkTblRec;

      acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],

                                      OpenMode.ForWrite) as BlockTableRecord;

 

      // Create a lightweight polyline创建轻型多段线

      Polyline acPoly = new Polyline();

      acPoly.AddVertexAt(0, new Point2d(1, 1), 0, 0, 0);

      acPoly.AddVertexAt(1, new Point2d(1, 2), 0, 0, 0);

      acPoly.AddVertexAt(2, new Point2d(2, 2), 0, 0, 0);

      acPoly.AddVertexAt(3, new Point2d(3, 2), 0, 0, 0);

      acPoly.AddVertexAt(4, new Point2d(4, 4), 0, 0, 0);

 

      // Add the new object to the block table record and the transaction

      //将新对象添加到块表记录和事务

      acBlkTblRec.AppendEntity(acPoly);

      acTrans.AddNewlyCreatedDBObject(acPoly, true);

 

      // Sets the bulge at index 3设置线段3的凸度

      acPoly.SetBulgeAt(3, -0.5);

 

      // Add a new vertex添加新顶点

      acPoly.AddVertexAt(5, new Point2d(4, 1), 0, 0, 0);

 

      // Sets the start and end width at index 4设置线段4的起止宽度

      acPoly.SetStartWidthAt(4, 0.1);

      acPoly.SetEndWidthAt(4, 0.5);

 

      // Close the polyline闭合多段线

      acPoly.Closed = true;

 

      // Save the new objects to the database提交修改

      acTrans.Commit();

  }

}

VBA/ActiveX Code Reference

Sub EditPolyline()

    Dim plineObj As AcadLWPolyline

    Dim points(0 To 9) As Double

 

    ' Define the 2D polyline points

    points(0) = 1: points(1) = 1

    points(2) = 1: points(3) = 2

    points(4) = 2: points(5) = 2

    points(6) = 3: points(7) = 2

    points(8) = 4: points(9) = 4

 

    ' Create a light weight Polyline object

    Set plineObj = ThisDrawing.ModelSpace. _

                                 AddLightWeightPolyline(points)

 

    ' Add a bulge to segment 3

    plineObj.SetBulge 3, -0.5

 

    ' Define the new vertex

    Dim newVertex(0 To 1) As Double

    newVertex(0) = 4: newVertex(1) = 1

 

    ' Add the vertex to the polyline

    plineObj.AddVertex 5, newVertex

 

    ' Set the width of the new segment

    plineObj.SetWidth 4, 0.1, 0.5

 

    ' Close the polyline

    plineObj.Closed = True

    plineObj.Update

End Sub

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值